#include <stdlib.h>
#include <stdio.h>

#include <gtk/gtk.h>
#include "gtkeditor.h"

#define BUF_MAX_SIZE 128	/* seems fair for one line */

static void
load_file (GtkEditor *editor, char *filename)
{
  char buf[BUF_MAX_SIZE];
  FILE *fp = fopen (filename, "r");

  if (!fp) return;

  g_print ("inserting %s\n", filename);

  /* load new */
  gtk_text_freeze (GTK_TEXT (editor));
  
  do {
    if (fgets (buf, BUF_MAX_SIZE, fp) == NULL) {
      break;
    } else {
      gtk_text_insert (GTK_TEXT (editor), NULL, NULL, NULL,
		       buf, strlen (buf));
    }
  } while (!feof (fp));

  gtk_text_thaw (GTK_TEXT (editor));

  /* clean up and hilite */
  fclose (fp);
  gtk_editor_hilite_buffer (editor);

  exit (2);			/* ready for profileing */
}


int
main (int argc, char *argv[]) 
{
  GtkWidget *window;
  GtkWidget *editor;

  /* args? */
  if (argc != 2) {
    g_warning ("wrong user error!");
    return EXIT_FAILURE;
  }

  /* initialize */
  gtk_init (&argc, &argv);

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  editor = gtk_editor_new(NULL, NULL);
  gtk_container_add (GTK_CONTAINER (window), editor);
  gtk_signal_connect_after (GTK_OBJECT (editor), "realize",
			    GTK_SIGNAL_FUNC (load_file), (gpointer)argv[1]);

  gtk_widget_show_all (window);


  /* main loop */
  gtk_main ();

  return EXIT_SUCCESS;
}
